(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
    Programmme de test de la carte son et de l'unit VOC.                   
Ĵ
  Fichiers ncessaires                                                    
                                                    
                                                                            
 'Term.voc'    \                                                            
 'Beavis.voc'   |                                                           
 'Ed209.voc'    |-> Quatres sons au format VOC (Creative)                   
 'Roe.voc'     /                                                            
*)

{$M 2048,0,68776}

uses
  Clavier,    { Pour lire une touche au clavier }
  EcranTxt,   { Pour l'cran texte }
  FaitPaus,   { Pour faire une pause }
  VOC;        { Pour tout ce qui concerne les sons VOC }

var
  Son: array[0..3] of record
    Adress: pointer;
    Taille: word;
  end;

  EtatPause : boolean;
  ch: char;
  i,X,Y: byte;
  Ver: word;

procedure Init; begin
  { Charge le driver en mmoire }
  ChargeDriverVoc;

  { Initialise le driver }
  InitVoc;

  InitModeTxt;

  { Affichage des informartions sur le driver }
  Ver := LitVersionDriverVoc;
  EcriT ('Le driver VOC est le fichier : '); EcriTcr (NomDriverVoc,10);
  EcriT ('Sa version est : ');
  EcriTnc (ver shr 8 and $FF,10);
  EcriT ('.');
  EcriTncr (ver and $FF,10);
  EcriTr ('');

  { Charge les sons }
  With son[0] do Adress := ChargeSonVoc ('Term'  ,Taille);
  With son[1] do Adress := ChargeSonVoc ('Beavis',Taille);
  With son[2] do Adress := ChargeSonVoc ('Ed209' ,Taille);
  With son[3] do Adress := ChargeSonVoc ('Roe'   ,Taille);

  { Affiche le menu }
  EcriTcr ('[ Voici la liste de mes sons ]',15+3*16);
  CoulTexte (14);
  EcriTr ('1 - Terminator');
  EcriTr ('2 - Beavis');
  EcriTr ('3 - ED 209');
  EcriTr (''); CoulTexte (9);
  EcriTr ('Espace - Pause');
  EcriTr ('Echape - Exit');
  EcriTr (''); CoulTexte (11);
  EcriTc  ('Slectionnez en un : ',15);
end;

procedure Fin; begin
  { Lit un dernier son avant de partir }
  if (DriverVOC.Etat=LitSon) then StopSonVoc;
  with son[3] do JoueSonVoc (Adress);
  repeat until (DriverVoc.Etat=PasSon);

  { S'occupe de l'cran }
  EcriTcr ('A+',14);

  { Ferme le driver et teind les haut-parleurs }
  FinVoc;

  { --- Efface les sons de la mmoire --- }
  with son[0] do LibereSonVoc (Adress,Taille);
  with son[1] do LibereSonVoc (Adress,Taille);
  with son[2] do LibereSonVoc (Adress,Taille);
  with son[3] do LibereSonVoc (Adress,Taille);

  Halt;
end;

begin
  Init;

  EtatPause := FALSE;
  repeat
     ch := LitTouche;

     Case ch of
     { De 1  3 : Lit un son }
     '1'..'3' :
     begin
       StopSonVoc;
       EcriT (ch);
       with Son[ Ord(ch)-49 ] do JoueSonVoc (Adress);
       PosX (EcranX-1);
     end;

     { Espace : Pause }
     _ESPACE: if DriverVoc.Etat=LitSon then begin
         CoulTexte (12); X := EcranX; Y := EcranY;
         EcriT ('PAUSE');
         PauseSonVoc;

         EtatPause := FALSE;
         repeat
           PosXY (x,y);
           if EtatPause then EcriT ('     ') else EcriT ('PAUSE');
           EtatPause := not EtatPause;
           for i := 0 to 49 do if not TouchPresse then pause (10);
         until TouchPresse;
         LitTouche;

         ContinueSonVoc;
         CoulTexte (11); EcriTx (x,y,'     ');
         PosXY (x,y);
       end;

     { Echape : On se tire }
     _ECHAPE: Fin;
     end; { de 'Case key of' }
  until FALSE;
end.